//
// FernsehWidget
// Von Pascal Pfiffner und Sebastian Krauß
//

var req;
var previous; // url für die vorigen sendungen
var further; // url für die nächsten sendungen
var currentlyloading;
var progressAnimationTimer;
var currentID;
var currentShowDescURL;
var isSearchResult;
var lastSearchDate;
var isQuickAccessSearch;
var quickAccessDay;
var elapsedTimeCanvasses;

// Which show was previously shown?
var previousShowObject;
var previousShowClass;

function selectValue(element, value)
{
	for (i = 0; i < element.length; i++)
	{
		if (element.options[i].value == value)
		{
			element.selectedIndex = i;
			return;
		}
	}
}

function loaded()
{
	currentID = 0;
	currentlyloading = false;
	isSearchResult = false;
	
	elapsedTimeCanvasses = new Array();
	
	scrollerInit(document.getElementById("myScrollBar"), document.getElementById("myScrollTrack"), document.getElementById("myScrollThumb"));

	// create buttons
	createGenericButton(document.getElementById("done"), "Fertig", savePrefs);

	createGenericButton(document.getElementById("diagnosisbutton"), "Netzwerk-Diagnose...", openDiagnosis);
	createGenericButton(document.getElementById("tryagainbutton"), "Erneut versuchen", getdefault);
	
	// setup prefs
	var opt = document.getElementById("ztag");
	var optvalue = widget.preferenceForKey("day");
	if (undefined != optvalue) selectValue(opt, optvalue);
	opt = document.getElementById("uhrzeit");
	optvalue = widget.preferenceForKey("hour");
	if (undefined != optvalue) selectValue(opt, optvalue);
	opt = document.getElementById("sparte");
	optvalue = widget.preferenceForKey("channelkind");
	if (undefined != optvalue) selectValue(opt, optvalue);
	opt = document.getElementById("sender");
	optvalue = widget.preferenceForKey("channel");
	if (undefined != optvalue) selectValue(opt, optvalue);
	optvalue = widget.preferenceForKey("showShortDesc");
	if ((optvalue != undefined) && (optvalue == "1")) document.getElementById("kurzInfoStandard").checked = true;
	opt = document.getElementById("erinnerung");
	optvalue = widget.preferenceForKey("reminder");
	if (undefined != optvalue)
	{
		selectValue(opt, optvalue);
		if (FernsehPlugin) FernsehPlugin.setSecondsBeforeReminder(optvalue);
		// 120 is the default in the widget and in the gui.
		// no need to explicitly set it.
	}
	
	// populate sounds
	var alarmSound = FernsehPlugin.timerSound();
	//alert ("default: "+ alarmSound);
	var selector = document.getElementById('alarmton');
	var sounds = FernsehPlugin.validSounds();
	var currentLibrary = 0;
	var a = 1;
	for(i = 0; i < sounds.length; i++) {
		var components = sounds[i].split("/");
		
		// new library; add separator
		if(currentLibrary != components[1]) {
			selector.appendChild(document.createElement("option"));
			selector.options[a].value = "";
			selector.options[a].innerHTML = "&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;";
			a++;
		}

		soundname = components[components.length-1];
		soundname = soundname.substring(0, soundname.indexOf(".", soundname.length -6));
		//alert(soundname);
		
		selector.appendChild(document.createElement("option"));
		selector.options[a].value = sounds[i];
		selector.options[a].innerHTML = (soundname.length > 0) ? soundname : "Systemsound";
		
		// select the right one
		if(sounds[i] == alarmSound) {
			selector.options[a].selected = true;
		}
		
		currentLibrary = components[1];
		a++;
	}
	
	if(window.widget)
	{
		widget.onshow = onShow;
		widget.onhide = onHide;
	}

	updateTVListing();
}	

function getdefault()
{
	isSearchResult = false;
	isQuickAccessSearch = false;
	document.getElementById("searchInput").value="";
	var day = getListingDay();
	var hour = getListingTime();
	var channelkind = getListingChannelKind();
	var channel = getListingChannel();
	
	var requesturl = "http://www.tvtoday.de/tv/programm/programm.php?ztag=" + day + "&sparte=" + channelkind + "&uhrzeit=" + hour + "&sender=" + channel;

	getURL(requesturl);	
}

function getListingDay()
{
	var opt = document.getElementById("ztag");
	var ret = opt.options[opt.selectedIndex].value;
	return ret;
}

function getListingTime()
{
	var opt = document.getElementById("uhrzeit");
	var ret = opt.options[opt.selectedIndex].value;
	return ret;
}

function getListingChannelKind()
{
	var opt = document.getElementById("sparte");
	var ret = opt.options[opt.selectedIndex].value;
	return ret;
}

function getListingChannel()
{
	var opt = document.getElementById("sender");;
	var ret = opt.options[opt.selectedIndex].value;
	return ret;
}

function getURL(requesturl)
{
	if (currentlyloading) return;
	currentlyloading = true;
	
	//alert(requesturl);
	if(drawer.current > 0) toggleDrawer();
	previousShowObject = null;
	previousShowClass = null;
	
	startProgressAnimation();

	req = new XMLHttpRequest();
	req.onreadystatechange = processReqChange;
	req.open("GET", requesturl, true);
	req.setRequestHeader("Cache-Control", "no-cache");

	req.send(null);
}

function processReqChange()
{
	// alert("State: "+req.readyState+" >> Status: "+req.status+" >> StatusText: "+req.statusText);
	if (req.readyState == 4) currentlyloading = false;
	if ((req.readyState == 4) && (req.status == undefined)) showError();
	if ((req.readyState == 4) && (req.status >= 200) && (req.status < 400)) parseRawHTML(req.responseText);

	// DEBUG ONLY!
	// if ((req.readyState == 4) && (req.status >= 400)) showError();
}

function showError()
{
	stopProgressAnimation();
	purgeParagraphs();
	document.getElementById('networkerror').style.display = 'block';
	calculateAndShowThumb(document.getElementById('content'));
}

function startProgressAnimation()
{
	startProgressBar();
}

function stopProgressAnimation()
{
	stopProgressBar();
}

function updateTVListing()
{
	getdefault();
}

var dateFirstShow;
function parseRawHTML(rawsource)
{
	// Das alles zu einer Zeile machen 
	lines = rawsource.split("\n");
	rsource = lines.join("");
	
	if (document.getElementById('helpdiv').style.display == 'block') hideHelp();
	
	if (isSearchResult && (rsource.indexOf("Der gesuchte Text ist in den Titeln der TV-Sendungen von gestern") != -1))
	{
		purgeParagraphs();
		stopProgressAnimation();
		document.getElementById('networkerror').style.display = 'none';
		document.getElementById('content').style.top = '0px';
		document.getElementById('content').innerHTML = "<div class=\"notFound\">Keine Sendung gefunden</div>";
		calculateAndShowThumb(document.getElementById('content'));
		return;
	}
	
	elapsedTimeCanvasses = new Array();

	try {
		// mal datum finden
		if (!isSearchResult) 
		{
			datematch = /((ContentAd Ende)|(Ende ContentAd)).*?<span class="headline-balken">&nbsp;&nbsp;P R O G R A M M.*?<span class="text-weiss">([0-9]{1,2}\.[0-9]{1,2}\.).*?<\/span>/;
			datematch.exec(rsource);
			dateFirstShow = RegExp.$4;
		
			dateFirstShow += ("" + (new Date()).getFullYear()).substr(2,2);
			document.getElementById('showdate').innerText = dateFirstShow;
		}
		else document.getElementById('showdate').innerText = "";
		
		// Der entscheidende Teil für das Fernsehprogramm...
		
		rmatch = /((ContentAd Ende)|(Ende ContentAd)).*?<\/table>.*?<img[^>]+><br>(.*?)<img[^>]+><br><br><table[^>]+width="566">(.*)$/;
	
		rmatch.exec(rsource);
		var listing = RegExp.$4;
		
		// Später relevant für "frühere Sendungen" und "weitere Sendungen"
		var afterlisting = RegExp.$5;
		
		shows = new Array();
		showsregexp = /<table border="0" cellpadding="4" cellspacing="0" width="566">\s?<tr>(.*?)<\/tr>/g;
		rawshows = listing.match(showsregexp);
		
		var searchdate;
	
		// Die einzelnen Sendungen zerpflücken
		for (i = 0; i < rawshows.length; i++)
		{
			singleshowregexp = /<td.*?>.*?<\/td>/g;
			thisshow = rawshows[i].match(singleshowregexp);
			
			iconurlregexp = /<td width="38" valign="top"><img src="([^"]*)" [^>]*alt="/;
			iconurlraw = thisshow[0].match(iconurlregexp);
			iconurl = iconurlraw[1];
			
			if (!isSearchResult)
			{
				starttimeregexp = /<td valign="top" bgcolor="#a8a8a8"><span class="text-grau">(.*?)<\/span/;
				starttimeraw = thisshow[1].match(starttimeregexp);
				starttime = starttimeraw[1];
				//alert("start "+starttime);
			} else {
				starttimeregexp = /<td valign="top" bgcolor="#a8a8a8"><span class="text-grau">([^>]*?)<br>([^>]*?)<\/span/;
				starttimeraw = thisshow[1].match(starttimeregexp);
				starttime = starttimeraw[1];
				startdate = starttimeraw[2];
				//alert (starttime + " >> " + startdate);
			}
			
			shownameregexp = /<td valign="middle" width="476"><span class="headline">(<a href.*?><u>)?(.*?)(<\/u>)?<\/span><span class="text">(.*?)\s.*?<\/span>.*?<span class="text">(.*?)\s.*?<\/span>/;
			shownameraw = thisshow[2].match(shownameregexp);
			shownameandchannel = shownameraw[2];
			//alert("start "+starttime);
			
			showurlregexp = /<td valign="middle" width="476"><span class="headline">.*?openWindowLupeCustom\('([^']*?)',/;
			showurlraw = thisshow[2].match(showurlregexp);
			var showurl = null;
			if (showurlraw != null) showurl = showurlraw[1];
			
			showchannelregexp = /(.*?)\s*\((.*)\)/
			showchannel = shownameandchannel.match(showchannelregexp);
			
			showname = showchannel[1];
			channel = showchannel[2];
			
			// mit showview
			//showdescregexp = /<td valign="middle" width="476">.*?<span class="text">\s*?<i>(.*?)\s*?<br>\s*?<\/span>.*?<span class="text">\s*?(.*?)\s*?(<br>)?\s*?<\/span>/;
			// ohne showview -- aber wer braucht das?
			showdescregexp = /<td valign="middle" width="476">.*?<span class="text">\s*?<i>(.*?)<\/i>.*?<\/span>.*?<span class="text">\s*?(.*?)\s*?(<br>)?\s*?<\/span>/;
			showdescraw = thisshow[2].match(showdescregexp);
			
			showlength = "";
			showlength = showdescraw[1];
			showdesc = "";
			if (undefined != showdescraw[2]) showdesc += showdescraw[2];
			
			if (!isSearchResult) show = new Array(channel, starttime, showname, iconurl, showdesc, showlength);
			else show = new Array(channel, starttime, showname, iconurl, showdesc, showlength, startdate);
	
			if (showurl != null) show.push(showurl);
			shows[i] = show;
		}
		var day = getListingDay();
	
		// Das Ergebnis zusammensetzen
		purgeParagraphs();
		
		for (i = 0; i < shows.length; i++)
		{
			thisshow = shows[i];
			showtitle = thisshow[2];
			longdesc = "";
			if (!isSearchResult)
			{
				if (thisshow.length == 7) longdesc = thisshow[6];
				addParagraph(thisshow[1], thisshow[0], showtitle, thisshow[4], longdesc, thisshow[3], thisshow[5]);
			} else {
				showdate = thisshow[6];
				
				if (lastSearchDate != showdate)
				{
					addDateHeader(showdate);
					lastSearchDate = showdate;
				}
				if (thisshow.length == 8) longdesc = thisshow[7];
				addParagraph(thisshow[1], thisshow[0], showtitle, thisshow[4], longdesc, thisshow[3], thisshow[5]);
			}
		}
		
		// Gibt es weitere oder vorherige Sendungen?
		
		previousregexp = /<a href="([^"]*)"><span class="link-intern"><img[^>]+bilder\/pfeil_links.gif[^>]+>&nbsp;fr&uuml;here Sendungen/;
		previousraw = afterlisting.match(previousregexp);
		previous = null;
		if (previousraw != undefined) previous = previousraw[1];
			
		furtherregexp = /<a href="([^"]*)"><span class="link-intern"> weitere Sendungen/;
		furtherraw = afterlisting.match(furtherregexp);
		further = null;
		if (furtherraw != undefined) further = furtherraw[1];
		
		if (previous == null) document.getElementById("previousShows").style.display = 'none';
		else document.getElementById("previousShows").style.display = 'block';
		
		if (further == null) document.getElementById("nextShows").style.display = 'none';
		else document.getElementById("nextShows").style.display = 'block';
		
		stopProgressAnimation();
		
		document.getElementById('networkerror').style.display = 'none';
		document.getElementById('content').style.top = '0px';
		calculateAndShowThumb(document.getElementById('content'));
	} catch (exc)
	{
		stopProgressAnimation();
		
		document.getElementById('networkerror').style.display = 'none';
		document.getElementById('content').style.top = '0px';
		document.getElementById('content').innerHTML = "<br /><div class=\"faded\">Beim Analysieren der Daten von TVToday ist ein Fehler aufgetreten.<br /><br />Dies kann unterschiedliche Ursachen haben, der wahrscheinlichste ist da&szlig; TVToday das Format seiner Seiten ver&auml;ndert hat.<br />In diesem Fall k&ouml;nnen Sie nur auf ein Update seitens der Entwickler warten.<br /><br /><a href='javascript:if(window.widget){widget.openURL(\"http://www.sebastian-krauss.de/software\");}'>Webseite &ouml;ffnen</a></div>";
		calculateAndShowThumb(document.getElementById('content'));
		document.getElementById("previousShows").style.display = 'none';
		document.getElementById("nextShows").style.display = 'none';
	}
}

function toggleShow(showName, time, channel, day, iconurl, buttonID)
{
	button = document.getElementById(buttonID);
	//alert("toggleshow called for show "+showName);
	if (FernsehPlugin.alarmExistsForShow(showName, channel, time, day)) 
	{
		button.setAttribute("src", "Images/AlarmOff.png");
			button.setAttribute('title', 'Alarm ist aus');
		FernsehPlugin.removeAlarmForShow(showName, channel, time, day);
	} else {
		button.setAttribute('src', 'Images/AlarmOn.png');
			button.setAttribute('title', 'Alarm ist an');
		FernsehPlugin.setAlarmForShow(showName, channel, time, day, iconurl);
	}
}

function toggleRowId(element, button)
{
	var nextelem = element.nextSibling;
	//alert("toggleRow called on element +"+nextelem+"+");
	
	if (nextelem.style.display == 'block')
	{
		nextelem.style.display = 'none';
		button.src='Images/iButton.png';
	} else {
		nextelem.style.display = 'block';
		button.src='Images/iButtonGrau.png';
	}
	calculateAndShowThumb(document.getElementById('content'));
	//alert("done togglerow");
}


var alternateParagraph = false;
function addParagraph(i_time, i_channel, i_title, i_desc, i_moreinfo, i_iconurl, i_showlength)
{
	var parent = document.getElementById('content');
	
	// main <p>
	var paragraph = document.createElement('p');
	var main_class = document.createAttribute('class');
	main_class.nodeValue = alternateParagraph ? 'mainRow2' : 'mainRow';
	paragraph.setAttributeNode(main_class);

	alternateParagraph = !alternateParagraph;
	
	var listingday = isSearchResult ? listingDayFromSearchDate() : getListingDay();
	if (isQuickAccessSearch) listingday = quickAccessDay;
	
	// checkbox
	var alarmCanBeSet = canSetAlarmForShow(i_time, listingday);
	var alarmExists = FernsehPlugin.alarmExistsForShow(i_title, i_channel, i_time, listingday);
	
	var checkbox = document.createElement('img');
	checkbox.setAttribute('class', "reminder");
	
	var canvasid = "-";
	var timeelapsed;
	
	if (!alarmCanBeSet)
	{
		if (i_showlength != "")
		{
			showlength = Math.abs((i_showlength.split(" "))[0]);

			var elapsed = elapsedMinutesSince(i_time);
			//alert(elapsed);
			timeelapsed = elapsed/showlength;
			
			//var title = "Gesamtlaufzeit " + geszeit + "\n" + Math.ceil(timeelapsed*showlength) + " Minuten gelaufen\n" + (showlength-Math.ceil(timeelapsed*showlength)) + " Minuten verbleibend";
			var title = minutesAsString(showlength) + " Gesamtlaufzeit\n" + minutesAsString(Math.ceil(timeelapsed*showlength)) + " gelaufen\n" + minutesAsString(showlength-Math.ceil(timeelapsed*showlength)) + " verbleibend";
			if (timeelapsed > 1)
			{
				title = "Sendung vorbei";
				timeelapsed = 1;
			}

			checkbox = document.createElement('canvas');
			checkbox.setAttribute('class', "reminder");
			var canvasid = "canvas-" + currentID++;
			checkbox.setAttribute('id', canvasid);
   			checkbox.setAttribute('title', title);
   			
   			elapsedTimeCanvasses[canvasid] = "" + timeelapsed;
		} else {
			 checkbox.setAttribute('src', 'Images/ProgramRunning.png');
			 checkbox.setAttribute('title', 'Sendung läuft');
		}
	} else {
		if (alarmExists)
		{
				checkbox.setAttribute('src', 'Images/AlarmOn.png');
				checkbox.setAttribute('title', 'Alarm ist an');
		} else {
				checkbox.setAttribute('src', 'Images/AlarmOff.png');
				checkbox.setAttribute('title', 'Alarm ist aus');
		}
		var thisButtonID = "buttonID"+currentID++;
		checkbox.setAttribute("id", thisButtonID);
		checkbox.setAttribute("onClick", "toggleShow(\"" + i_title + "\",\"" + i_time + "\",\"" + i_channel + "\",\"" + listingday + "\",\"" + i_iconurl + "\",\"" + thisButtonID + "\");");
	}

	paragraph.appendChild(checkbox);
	
	// the time
	var time = document.createElement('div');
	time.setAttribute('class', "time");
	var time_data = document.createTextNode(i_time);
	time.appendChild(time_data);
	
	paragraph.appendChild(time);
	
	// channel
	var channel = document.createElement('div');
	channel.setAttribute("class", "channel");
	var channel_data = document.createTextNode(i_channel);
	channel.appendChild(channel_data);
	
	paragraph.appendChild(channel);
	
	// title
	var title_data = document.createTextNode(i_title);
	if(i_moreinfo != "") {
		var title_link = document.createElement('a');
		var paraID = "infoParagraphID" + currentID++;
		title_link.setAttribute("href", 'javascript:getShowDescription("' + i_moreinfo + '", "' + paraID + '");');
		paragraph.setAttribute('id', paraID);
		title_link.appendChild(title_data);
		paragraph.appendChild(title_link);
	}
	else {
		paragraph.appendChild(title_data);
	}
	
	// togglebutton
	if(i_desc) {
		var descs = i_desc.split("<br>");
		 var showDescOn = document.getElementById("kurzInfoStandard").checked;
		var img = document.createElement('img');
		if (showDescOn) img.setAttribute('src', "Images/iButtonGrau.png");
		else img.setAttribute('src', "Images/iButton.png");
		img.setAttribute('class', "toggleshortinfo");
		img.setAttribute('onclick', "toggleRowId(this.parentNode, this)");
		
		paragraph.appendChild(img);
	
		// moreinfo
		var desc = document.createElement('p');
		var desc_class = document.createAttribute('class');
		desc_class.nodeValue = 'descRow';
		var desc_data = document.createTextNode(descs[0]);
		
		desc.setAttributeNode(desc_class);
		
		if (showDescOn) desc.style.display = 'block';
		
		desc.appendChild(desc_data);
		
		// "<br>anschl. Nachrichten"
		for (z = 1; z < descs.length; z++)
		{
			desc.appendChild(document.createElement("br"));
			var textnode = document.createTextNode(descs[z]);
			desc.appendChild(textnode);
		}
		
		if (i_showlength != "")
		{
			// if available, add the length of the show below the short desc
			var showlength = document.createElement('span');
			var showlength_class = document.createAttribute('class');
			showlength_class.nodeValue = 'showlength';
			
			showlength.setAttributeNode(showlength_class);
			showlength.appendChild(document.createTextNode(i_showlength));
			
			desc.appendChild(showlength);
		}
	}
	
	// append
	parent.appendChild(paragraph);
	if(i_desc)
		parent.appendChild(desc);
	if (canvasid != "-") drawElapsed(canvasid, timeelapsed);
}

function minutesAsString(minutes)
{
	var result = Math.floor(minutes / 60) + ":";
	var remMins = (minutes % 60);
				
	if (remMins < 10) result += "0" + remMins
	else result += remMins;
	
	return result;
}


function elapsedMinutesSince(time)
{
	var date = new Date();
	var nowHour = date.getHours();
	var nowMinute = date.getMinutes();
	var showDate = time.split(".");
	var showHour = Math.abs(showDate[0]);
	// show from previous day?
	if (showHour > nowHour) nowHour += 24;
	var showMinute = Math.abs(showDate[1]);
	var nowInMinutes = (60 * nowHour) + nowMinute;
	var showInMinutes = (60 * showHour) + showMinute;	
	return nowInMinutes-showInMinutes;
}

function drawElapsed(canvasid, timeelapsed)
{
	/*var xMid = 5;
	var yMid = 5.5;
	var rad = 5;*/
	var canvas = document.getElementById(canvasid);
	var context = canvas.getContext("2d");
	context.clearRect(0,0,12,12);
	context.beginPath();
	context.arc(6, 6, 5.5, 0, 6.2831853072, true);
	context.closePath();
		
	context.lineWith = 0.3;
	context.setStrokeColor("#999999");
	context.stroke();
	
	context.setFillColor("#FFFFFF");
	context.fill();

	if (timeelapsed > 0)
	{
		context.beginPath();
		context.moveTo(6, 6);
		// -1.5707963268 ^=  -90 degrees, 12 o'clock on a watch in this case
		context.arc(6, 6, 5.5, -1.5707963268, (timeelapsed * 6.2831853072) - 1.5707963268, false);
		context.closePath();
		context.setFillColor("#888888");
		context.fill();
	}
}

// work around a bug in webkit
function redrawElapsed()
{
	for (var canvasid in elapsedTimeCanvasses)
	{
		drawElapsed(canvasid, parseFloat(elapsedTimeCanvasses[canvasid]));
	}
}

function addDateHeader(date)
{
	var parent = document.getElementById('content');
	
	// main <p>
	var paragraph = document.createElement('p');
	paragraph.setAttribute("class", "dateRow");
	
	var components = date.split(".");
	var showday = Math.abs(components[0]);
	var showmonth = Math.abs(components[1])-1; // months are 1 off, [0..11]
	
	var now = new Date();
	
	var nowDate = new Date(now.getFullYear(), now.getMonth(), now.getDate());
	var showDate = new Date(now.getFullYear(), showmonth, showday);
	
	// next year, search took place end december, result in january
	if (showmonth < now.getMonth()) showDate.setFullYear(now.getFullYear()+1);
	
	var tage = new Array("Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Sonnabend");
	
	var longDate = tage[showDate.getDay()] + ", " + date;
	
	var date_data = document.createTextNode(longDate);
	
	paragraph.appendChild(date_data);
	parent.appendChild(paragraph);
}


function purgeParagraphs() {
	var parent = document.getElementById('content');
	var elements = parent.childNodes;
	var a = elements.length;
	
	for(i = a-1; i >= 0; i--) {
		if(elements[i] != null)
			parent.removeChild(elements[i]);
	}
}

function listingDayFromSearchDate()
{
	var components = lastSearchDate.split(".");
	var showday = Math.abs(components[0]);
	var showmonth = Math.abs(components[1])-1; // months are 1 off, [0..11]
	
	var now = new Date();
	
	var nowDate = new Date(now.getFullYear(), now.getMonth(), now.getDate());
	var showDate = new Date(now.getFullYear(), showmonth, showday);
	
	// next year, search took place end december, result in january
	if (showmonth < now.getMonth()) showDate.setFullYear(now.getFullYear()+1);
	
	var daysbetween = (showDate - nowDate) / 86400000;
	
	return daysbetween;
}

function canSetAlarmForShow(time, day)
{
	if ((day == 8) && !isSearchResult) return false; // gestern
	if (day > 0) return true;
	
	var showDay;
	var now = new Date();

	var showDate = time.split(".");
	var showHour = Math.abs(showDate[0]);
	var showMinute = Math.abs(showDate[1]);
	
	if((showHour <= 5) && (now.getHours() >= 12))
		showDay = now.getDate() + 1;
	else if((showHour > 5) && (now.getHours() <= 5))
		showDay = now.getDate() - 1;
	else
		showDay = now.getDate();
	
	var theShow = new Date(now.getFullYear(), now.getMonth(), showDay, showHour, showMinute, 00);
	
	return (now < theShow);
	
	var date = new Date();
	var nowHour = date.getHours();
	var nowMinute = date.getMinutes();
	var nowInMinutes = (60 * nowHour) + nowMinute;
	var showDate = time.split(".");
	var showHour = Math.abs(showDate[0]);
	var showMinute = Math.abs(showDate[1]);
	var showInMinutes = (60 * showHour) + showMinute;	
	
	//alert(time + " >> " + showDate[0] +" >> "+showDate[1]);
	//alert("nh "+nowHour + " >> nm " + nowMinute + " >> sh "+showHour+" >> sm "+showMinute +" >> nim "+nowInMinutes +" >> sim "+showInMinutes);
	
	if (showInMinutes > nowInMinutes) return true;
	
	if ((nowHour > 4) && (showHour <= 4)) return true; // "now" is past 4, show starts past midnight, before 4; assume next day
	return false;
}

function getShowDescription(requesturl, callingID)
{
	if (currentlyloading) return;
	currentlyloading = true;
	
	callingobj = document.getElementById(callingID);
	
	if (null != previousShowObject)
	{
		previousShowObject.setAttribute('class', previousShowClass);
	}
	previousShowObject = callingobj;
	previousShowClass = previousShowObject.getAttribute("class");
	callingobj.setAttribute('class', 'highlightrow');

	document.getElementById('drawercontent').innerHTML = "<div class=\"faded\">Lade Beschreibung...</div>";
	resizeDrawer();
	
	currentShowDescURL = requesturl;

	req = new XMLHttpRequest();
	req.onreadystatechange = parseShowDescription;
	req.open("GET", requesturl, true);
	req.setRequestHeader("Cache-Control", "no-cache");
	req.send(null);
}

function parseShowDescription()
{
	//alert('parseShowDescription() called');
	if (req.readyState == 4) currentlyloading = false;
	if ((req.readyState == 4) && (req.status == undefined))
	{
		document.getElementById('drawercontent').innerHTML = "";
		resizeDrawer();

		showError();
		return;
	}
	if (!((req.readyState == 4) && (req.status >= 200) && (req.status < 400))) return;
	
	var show = "";
	try {
		rawShow = req.responseText;
		lines = rawShow.split("\n");
		rsource = lines.join("");
		
		showregexp = /<\/table>\s*<span class="text">(.*?)\s*<\/span/;
		showraw = rsource.match(showregexp);
		show = showraw[1];
		
		// sometimes they link to descriptions, but the description is "xxx".
		// instead of displaying "xxx" as description, say that there is none.
		if (show.length < 6)
		{
			show = "<div class=\"faded\">Keine Beschreibung vorhanden.</div>";
			document.getElementById('drawercontent').innerHTML = show;
			resizeDrawer();
			return;
		}
		//if ((show.length < 6) && (show.indexOf("xxx") != -1)) show = "<div class=\"faded\">Keine Beschreibung vorhanden.</div>";
		
		var startsearch = (show.length / 2) + 1;
		var doSearch = true;
		
		while (doSearch)
		{
			var thischar = show.charAt(--startsearch);
			if ((thischar == ' ') || (thischar == '.')) doSearch = false;
			
			if (startsearch == 0) doSearch = false;
		}
		
		//alert(show);
		show = show.substring(0, startsearch);
		//alert(show);
		
		show += "&hellip;<br /><a href=\"javascript:widget.openURL('" + currentShowDescURL + "');\">Mehr &#187;</a>";
	} catch (exc)
	{
		// Happens if there is no description. Honestly.
		show = "<div class=\"faded\">Keine Beschreibung vorhanden.</div>"; 
	}
	
	document.getElementById('drawercontent').innerHTML = show;
	resizeDrawer();
}

function showPrevious()
{
	if (previous == null) return;
	lastSearchDate = "";
	getURL("http://www.tvtoday.de" + previous);
}

function showNext()
{
	if (further == null) return;
	lastSearchDate = "";
	getURL("http://www.tvtoday.de" + further);
}

function scrollwheel(event, whatdiv)
{
	if (scrollTrack.style.display == 'none') return;
	delta = window.event.wheelDelta/10;
	// delta > 0 rad nach oben
	// delta < 0 rad nach unten
	
	//var newv = (parseInt(document.getElementById('content').style.top.replace(/px/, ''))) + delta;
	var newv = (parseInt(whatdiv.style.top.replace(/px/, ''))) + delta;
	newv += 'px';
	//document.getElementById('content').style.top = newv;
	//calculateAndShowThumb(document.getElementById('content'));
	whatdiv.style.top = newv;
	calculateAndShowThumb(whatdiv);
}

function reminderIntervalChanged()
{
	var opt = document.getElementById("erinnerung");
	var optval = opt.options[opt.selectedIndex].value;

	if (FernsehPlugin) FernsehPlugin.setSecondsBeforeReminder(""+optval);
}

function openDiagnosis()
{
	if(window.widget)
		 widget.openApplication("com.apple.NetworkDiagnostics");
}

function searchShow(searchstring)
{
	if (searchstring == "")
	{
		if (isSearchResult) getdefault();
		return;
	}
	lastSearchDate = "";
	isSearchResult = true;
	isQuickAccessSearch = false;
	var requrl = "http://www.tvtoday.de/tv/programm/programm.php?ztag=0&uhrzeit=jetzt&sparte=alle&sender=HS&suchbegriff="+escape(searchstring);
	getURL(requrl);
}

function showHelp()
{
	var front = document.getElementById("frontDiv");
	var back = document.getElementById("prefDiv");
	
	if(window.widget)
		widget.prepareForTransition("ToFront");
				
	front.style.display = "block";
	back.style.display = "none";
		
	if(window.widget)
		setTimeout("widget.performTransition();", 0);
	document.getElementById('helpdiv').style.display = 'block';
	document.getElementById('content').style.display = 'none';
	document.getElementById('closeHelp').style.display = 'block';
	document.getElementById('searchInput').style.display = 'none';
	document.getElementById('toggledrawer').style.display = 'none';
	document.getElementById('shortcutscover').style.display = 'none';
	document.getElementById('shortcuts').style.display = 'none';
	document.getElementById('previousShows').style.display = 'none';
	document.getElementById('nextShows').style.display = 'none';
	calculateAndShowThumb(document.getElementById('helpdiv'));
}

function hideHelp()
{
	if (null != previous) document.getElementById('previousShows').style.display = 'block';
	if (null != further) document.getElementById('nextShows').style.display = 'block';
	document.getElementById('toggledrawer').style.display = 'block';
	document.getElementById('closeHelp').style.display = 'none';
	document.getElementById('searchInput').style.display = 'inline';
	document.getElementById('shortcutscover').style.display = 'block';
	document.getElementById('shortcuts').style.display = 'block';
	document.getElementById('helpdiv').style.display = 'none';
	document.getElementById('content').style.display = 'block';
	calculateAndShowThumb(document.getElementById('content'));
	redrawElapsed();
}

/*function toggleHelp()
{
	if (document.getElementById('helpdiv').style.display == 'block')
	{
		document.getElementById('helpdiv').style.display = 'none';
		document.getElementById('content').style.display = 'block';
		calculateAndShowThumb(document.getElementById('content'));
	} else {
		document.getElementById('helpdiv').style.display = 'block';
		document.getElementById('content').style.display = 'none';
		calculateAndShowThumb(document.getElementById('helpdiv'));
	}
}*/

function shortcutChosen()
{
	var opt = document.getElementById('shortcuts')
	var optval = opt.options[opt.selectedIndex].value;
	
	if (optval == "-")
	{
		getdefault();
		return;
	}
	
	var options = optval.split("/");
	
	isSearchResult = false;
	document.getElementById("searchInput").value="";
	var day = options[0];
	var hour = options[1];
	var channel = options[2];
	
	isQuickAccessSearch = true;
	quickAccessDay = day;
	
	var requesturl = "http://www.tvtoday.de/tv/programm/programm.php?ztag=" + day + "&sparte=alle&uhrzeit=" + hour + "&sender=" + channel;

	getURL(requesturl);	


}

function timerSoundChanged()
{
	var opt = document.getElementById("alarmton");
	var optval = opt.options[opt.selectedIndex].value;

	if (FernsehPlugin) FernsehPlugin.setTimerSound(optval);
}
